#define RHO 0.141047396
/*3:*/
#line 62 "bin-tree.w"

#include <stdio.h> 
#include <stdlib.h> 
#include <math.h> 
#define FALSE 0
#define TRUE !FALSE
/*5:*/
#line 136 "bin-tree.w"

static double*sqr= NULL;
static double**prob_table= NULL;
static int N= 0;


/*:5*//*16:*/
#line 261 "bin-tree.w"

static int rtree_height= 0;
static int rtree_ipl= 0;

/*:16*//*23:*/
#line 326 "bin-tree.w"

static const char*dtree_nodetype= NULL;
static FILE*dtree_output= NULL;

/*:23*/
#line 68 "bin-tree.w"

/*15:*/
#line 255 "bin-tree.w"

static void random_tree_paramsR(int,int);

/*:15*//*22:*/
#line 320 "bin-tree.w"

static void draw_random_treeR(int,int);

/*:22*/
#line 69 "bin-tree.w"

/*6:*/
#line 149 "bin-tree.w"

int init_bin_tree_gen(int n)
{
if(n<2)return FALSE;
/*7:*/
#line 162 "bin-tree.w"

{
int i;
sqr= malloc((n+1)*sizeof(double));
if(sqr==NULL)return FALSE;

prob_table= malloc((n+1)*sizeof(double*));
if(prob_table==NULL)return FALSE;

for(i= 2;i<=n;i++){
prob_table[i]= malloc(i*sizeof(double));
if(prob_table[i]==NULL)return FALSE;
}
}

/*:7*/
#line 153 "bin-tree.w"

/*8:*/
#line 177 "bin-tree.w"

{
int i;
sqr[0]= 0;sqr[1]= 1;
for(i= 2;i<=n;sqr[i++]= sqrt(i));
}

/*:8*/
#line 154 "bin-tree.w"

/*9:*/
#line 187 "bin-tree.w"

{
int i;
for(i= 2;i<=n;i++){
int j,max= i-1;
double rho= RHO*(i+1)*sqr[i];
prob_table[i][0]= (double)(i+1)/(4*i-2);
for(j= 1;j<max;j++)
prob_table[i][j]= prob_table[i][j-1]+(rho/((j+1)*(i-j)*sqr[j]*sqr[i-1-j]));
prob_table[i][max]= 2.0;
}
}

/*:9*/
#line 155 "bin-tree.w"

free(sqr);
sqr= NULL;
N= n;
return TRUE;
}

/*:6*//*10:*/
#line 204 "bin-tree.w"

void deinit_bin_tree_gen()
{
int i;
for(i= 2;i<=N;free(prob_table[i++]));
free(prob_table);
prob_table= NULL;
N= 0;
}

/*:10*//*12:*/
#line 228 "bin-tree.w"

static void random_tree_paramsR(int n,int depth)
{
/*13:*/
#line 236 "bin-tree.w"

if(n==0)
return;
else if(n==1){
if(depth+1> rtree_height)rtree_height= depth+1;
rtree_ipl+= depth;
return;
}

/*:13*/
#line 231 "bin-tree.w"

rtree_ipl+= depth;
/*14:*/
#line 245 "bin-tree.w"

{
int i;
double temp= (double)rand()/RAND_MAX;
for(i= 0;i<n;i++)
if(temp<prob_table[n][i])break;
random_tree_paramsR(i,depth+1);
random_tree_paramsR(n-1-i,depth+1);
}

/*:14*/
#line 233 "bin-tree.w"

}

/*:12*//*17:*/
#line 268 "bin-tree.w"

void random_tree_params(int n,int*height,int*ipl)
{
rtree_height= 0;
rtree_ipl= 0;
random_tree_paramsR(n,0);
*height= rtree_height;
*ipl= rtree_ipl;
}

/*:17*//*19:*/
#line 285 "bin-tree.w"

static void draw_random_treeR(int n,int depth)
{
/*21:*/
#line 308 "bin-tree.w"

if(n==0){
fprintf(dtree_output,"\\Tn ");
return;
}
else if(n==1){
if(depth+1> rtree_height)rtree_height= depth+1;
fprintf(dtree_output,"%s ",dtree_nodetype);
rtree_ipl+= depth;
return;
}

/*:21*/
#line 288 "bin-tree.w"

rtree_ipl+= depth;
fprintf(dtree_output,"\\pstree{%s}{\n",dtree_nodetype);
/*20:*/
#line 295 "bin-tree.w"

{
int i;
double temp= (double)rand()/RAND_MAX;
for(i= 0;i<n;i++)
if(temp<prob_table[n][i])break;
draw_random_treeR(i,depth+1);
draw_random_treeR(n-1-i,depth+1);
}

/*:20*/
#line 291 "bin-tree.w"

fprintf(dtree_output,"\n}");
}

/*:19*//*24:*/
#line 343 "bin-tree.w"

void draw_random_tree(int n,int*height,int*ipl,const char*levelsep,const char*treesep,
const char*nodetype,FILE*output)
{
rtree_height= 0;
rtree_ipl= 0;
dtree_output= output;
dtree_nodetype= nodetype;
fprintf(output,"\\pstree[levelsep=%s, treesep=%s]{%s}{\n",levelsep,
treesep,nodetype);
/*25:*/
#line 359 "bin-tree.w"

{
int i;
double temp= (double)rand()/RAND_MAX;
for(i= 0;i<n;i++)
if(temp<prob_table[n][i])break;
draw_random_treeR(i,1);
draw_random_treeR(n-1-i,1);
}

/*:25*/
#line 353 "bin-tree.w"

fprintf(output,"\n}");
*height= rtree_height;
*ipl= rtree_ipl;
}

/*:24*/
#line 70 "bin-tree.w"


/*:3*/
