#include <stdio.h>
#include <stdlib.h>

int ipl;
int len;

int ipl_calc(char* tree, int pos, int depth)
{
  int ret;

  if(tree[pos] == '0') return (pos+1) % len;

  ipl += depth;
  ret = ipl_calc(tree, (pos+1) % len, depth+1);
  return ipl_calc(tree, ret, depth+1);
}

int main(int argc, char* argv[])
{
  int i;
  int acumulador = 0;
  int N = atoi(argv[1]);
  char tree[100000];

  len = 2 * N + 1;

  /* Preenche o vetor com o nmero adequado de zeros e uns */
  for(i = 0; i < N; i++)
    tree[i] = '1';
  for( ; i < len; i++)
    tree[i] = '0';

  /* Inicia o clculo */
  for(i = 0; i < 1000; i++) {
    int j, k;
    int soma;

    /* Permuta o vetor tree */
    for(j = 0; j < len; j++) {
      int npos = (int) ((double) len * rand() / (RAND_MAX + 1.0));
      int temp = tree[npos];
      tree[npos] = tree[j];
      tree[j] = temp;
    }

    /* A partir de que elemento formamos uma rvore */
    for(j = 0; j < len; ) {
      for(k = j, soma = 0; soma >= 0; k = (k+1) % len) {
	if(tree[k] == '0') soma--;
	else soma++;
      }

      if(j == 0 && k == 0) break;  /* Encontramos a rvore */
      if(j != 0 && k == j) break;
      
      j = k;
    }
    
    /* Calculamos o ipl */
    ipl = 0;
    ipl_calc(tree, j, 0);
    acumulador += ipl;
  }

  printf("%f\n", (double) acumulador / 1000);
  
  return 0;
}

    


