/*3:*/
#line 74 "tree-stat.w"

#include <stdio.h> 
#include <stdlib.h> 
#include <time.h> 
#include "bin-tree.h"
#define FALSE 0
#define TRUE !FALSE
/*4:*/
#line 83 "tree-stat.w"

int main(int argc,char*argv[])
{
/*6:*/
#line 147 "tree-stat.w"

int draw_tree= FALSE;
int gen_tables= FALSE;
int seed= time(NULL);
int rep= 1000;
int N= 100;
char level_sep[]= "5mm\0       ";
char tree_sep[]= "5mm\0       ";
char node_type[]= "\\Tc*{2pt}\0      ";

/*:6*//*7:*/
#line 160 "tree-stat.w"

int height;
int ipl;

/*:7*/
#line 86 "tree-stat.w"

/*5:*/
#line 92 "tree-stat.w"

{
int i;

if(argc<2||(argc>=2&&(argv[1][0]!='b'&&argv[1][0]!='p'))){
fprintf(stderr,"Uso: tree-stat {bp} -[d] -[srN]nmero -[ltn]string\n");
return 1;
}

for(i= 2;i<argc;i++){
if(argv[i][0]!='-'){
fprintf(stderr,"Uso: tree-stat {b]} -[d] -[srN]nmero -[ltn]string\n");
return 1;
}

if(argv[i][1]=='d'){
draw_tree= TRUE;
continue;
}
else if(argv[i][1]=='h'){
gen_tables= TRUE;
continue;
}
else if(!argv[i][2])continue;

switch(argv[i][1]){
case's':
sscanf(argv[i]+2,"%d",&seed);
break;
case'r':
sscanf(argv[i]+2,"%d",&rep);
break;
case'N':
sscanf(argv[i]+2,"%d",&N);
break;
case'l':
sscanf(argv[i]+2,"%s",level_sep);
break;
case't':
sscanf(argv[i]+2,"%s",tree_sep);
break;
case'n':
sscanf(argv[i]+2,"%s",node_type);
break;
default:
fprintf(stderr,"Uso: tree-stat {b]} -[d] -[srN]nmero -[ltn]string\n");
return 1;
}
}
}

/*:5*/
#line 87 "tree-stat.w"

/*8:*/
#line 164 "tree-stat.w"

srand(seed);
if(argv[1][0]=='b'){
if(!init_bin_tree_gen(N)){
fprintf(stderr,"Erro ao inicializar mdulo bin-tree\n");
return 1;
}
if(draw_tree){
draw_random_tree(N,&height,&ipl,level_sep,tree_sep,node_type,stdout);
fprintf(stderr,"Altura: %d\n",height);
fprintf(stderr,"IPL: %d\n",ipl);
}
else/*9:*/
#line 184 "tree-stat.w"

{
if(gen_tables){
/*11:*/
#line 231 "tree-stat.w"

int*height_table= NULL;
int*ipl_table= NULL;

if((height_table= calloc(N+1,sizeof(int)))==NULL){
fprintf(stderr,"Erro de alocao de memria\n");
return 1;
}
if((ipl_table= calloc(1+(N*(N-1))/2,sizeof(int)))==NULL){
fprintf(stderr,"Erro de alocao de memria\n");
return 1;
}

/*:11*/
#line 187 "tree-stat.w"

/*12:*/
#line 244 "tree-stat.w"

{
int i;
double ave_height= 0;
double ave_ipl= 0;
for(i= 0;i<rep;i++){
random_tree_params(N,&height,&ipl);
ave_height+= height;
ave_ipl+= ipl;
height_table[height]++;
ipl_table[ipl]++;
}
fprintf(stdout,"Altura mdia: %f\n",ave_height/rep);
fprintf(stdout,"IPL mdio: %f\n",ave_ipl/rep);
fprintf(stdout,"EPL mdio: %f\n",ave_ipl/rep+2*N);
}

/*:12*/
#line 188 "tree-stat.w"

/*13:*/
#line 261 "tree-stat.w"

{
int i,max;
fprintf(stdout,"Tabela de alturas\n");
for(i= 0,max= N+1;i<max;i++)
if(height_table[i])fprintf(stdout,"%d %d\n",i,height_table[i]);
fprintf(stdout,"Tabela de IPLs\n");
for(i= 0,max= 1+(N*(N-1))/2;i<max;i++)
if(ipl_table[i])fprintf(stdout,"%d %d\n",i,ipl_table[i]);
free(height_table);
free(ipl_table);
}

/*:13*/
#line 189 "tree-stat.w"

}
else
/*10:*/
#line 198 "tree-stat.w"

{
int i;
double ave_height= 0;
double ave_ipl= 0;
for(i= 0;i<rep;i++){
random_tree_params(N,&height,&ipl);
ave_height+= height;
ave_ipl+= ipl;
}
fprintf(stdout,"Altura mdia: %f\n",ave_height/rep);
fprintf(stdout,"IPL mdio: %f\n",ave_ipl/rep);
fprintf(stdout,"EPL mdio: %f\n",ave_ipl/rep+2*N);
}

/*:10*/
#line 192 "tree-stat.w"

}

/*:9*/
#line 176 "tree-stat.w"

deinit_bin_tree_gen();
}

/*:8*/
#line 88 "tree-stat.w"

return 0;
}

/*:4*/
#line 81 "tree-stat.w"


/*:3*/
